include:
  - project: 'cde106/devcloud/dat/ci'
    ref: 0.0.2
    file: '.pypi-nexus.ci.yaml'
  - project: 'cde106/devcloud/dat/ci'
    ref: 0.0.2
    file: '/templates/common/publish.yaml'

variables:
  APP_VERSION: "1.0.7"

stages:
  - deploy
  - build
  - clean
  - quality

deploy to nexus:
  stage: deploy

build image:
  extends: .kaniko-build
  stage: build
  variables:
    DISABLE_KANIKO_CACHE: "true"
    ENABLE_VERSION_TAG: "true"
    VERSION: $APP_VERSION
    DOCKERFILE_PATH: ".rgs/docker/Dockerfile"
    IMAGE_NAME: "k8s_cleaner"
    BUILD_ARGS: >-
      --build-arg VERSION
      --build-arg KUBECONF
      --build-arg REGISTRY_URL
  only:
    - tags
  needs: ["deploy to nexus"]

  
.clean_k8s:
  stage: clean
  image: $REGISTRY_URL/platform/cleaners/kubernetes-deployment-cleaner/k8s_cleaner/release:$APP_VERSION
  script:
    - rgs-k8s-cleaner

    
.clean_k8s_normal:
  extends: .clean_k8s
  variables:
    LOGGING_LEVEL: "INFO"
  only:
    - master

.clean_k8s_debug:
  extends: .clean_k8s
  variables:
    LOGGING_LEVEL: "DEBUG"
    DEBUG_MODE: "true" # dryrun
  only:
    - debug
  when: manual



clean dev:
  extends: .clean_k8s_normal
  tags:
    - k8s
    - development
  variables:
    CLEANER_ENVIRONMENT: "DEV"

clean prod:
  extends: .clean_k8s_normal
  tags:
    - k8s
    - production
  variables:
    CLEANER_ENVIRONMENT: "PROD"



debug dev:
  extends: .clean_k8s_debug
  tags:
    - k8s
    - development
  variables:
    CLEANER_ENVIRONMENT: "DEV"

debug prod:
  extends: .clean_k8s_debug
  tags:
    - k8s
    - production
  variables:
    CLEANER_ENVIRONMENT: "PROD"
